#!/bin/sh
+# Configuration validation subroutine script, version 1.0.
+# Copyright (C) 1991, 1992 Free Software Foundation, Inc.
+
+#This file is free software; you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation; either version 2 of the License, or
+#(at your option) any later version.
+
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+
+#You should have received a copy of the GNU General Public License
+#along with this program; if not, write to the Free Software
+#Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+
# Configuration subroutine to validate and canonicalize a configuration type.
# Supply the specified configuration type as an argument.
# a failure to support a valid configuration from a meaningless
# configuration.
-# Separate what the user gave into CPU-company and OS (if any).
-basic_machine=`echo $1 | sed 's/-[^-]*$//'`
+# The goal of this file is to map all the various variations of a given
+# machine specification into a single specification in the form:
+# CPU_TYPE-MANUFACTURER-OPERATING_SYSTEM
+# it is wrong to echo any other type of specification
+
+if [ x$1 = x ]
+then
+ echo Configuration name missing. 1>&2
+ echo "Usage: $0 CPU-MFR-OPSYS" 1>&2
+ echo "or $0 ALIAS" 1>&2
+ echo where ALIAS is a recognized configuration type. 1>&2
+ exit 1
+fi
+
+# First pass through any local machine types.
+case $1 in
+ *local*)
+ echo $1
+ exit 0
+ ;;
+ *)
+ ;;
+esac
+
+# Separate what the user gave into CPU-COMPANY and OS (if any).
+basic_machine=`echo $1 | sed 's/-[^-][^-]*$//'`
if [ $basic_machine != $1 ]
-then os=`echo $1 | sed 's/^.*-/-/'`
+then os=`echo $1 | sed 's/.*-/-/'`
else os=; fi
-# Decode aliases for certain machine-company combinations.
+# Lets recognize common machines as not being OS so that things like
+# config.subr decstation-3100 as legal.
+case $os in
+ -dec* | -mips* | -sequent* | -encore* | -pc532* | -sgi* | -sony* | \
+ -att* | -7300* | -3300* | -delta* | -motorola* | -sun[234]* | \
+ -unicom* | -ibm* | -next* | -hp | -isi* | -apollo | -altos* | \
+ -convergent* | -ncr* | -news | -32* | -3600* | -3100* | -osf* | \
+ -c[123]* | -convex* | -sun | -crds | -omron* | -dg | -ultra | -tti* | \
+ -harris | -sim)
+ os=
+ basic_machine=$1
+ ;;
+ -scout)
+ ;;
+ -sco*)
+ os=-scosysv322
+ basic_machine=i386-unknown
+ ;;
+ -OSE68k | -ose68k | -OSE | -ose | -es1800)
+ os=-ose
+ basic_machine=m68k-ericsson
+ ;;
+ -OSE68000 | -ose68000)
+ os=-ose
+ basic_machine=m68000-ericsson
+ ;;
+ -isc*)
+ os=-iscsysv
+ basic_machine=i386-unknown
+ ;;
+# start-sanitize-v9
+ -32)
+ basic_machine=sparc64-hal
+ os=-hal32
+ ;;
+ -64)
+ basic_machine=sparc64-hal
+ os=-hal64
+ ;;
+ -v7)
+ basic_machine=sparc64-sun
+ os=-v7
+ ;;
+# end-sanitize-v9
+esac
+
+# Decode aliases for certain CPU-COMPANY combinations.
case $basic_machine in
- # Recognize the basic CPU types without company name.
- vax | tahoe | i386 | i860 | m68k | m68000 | m88k | sparc | ns32k \
- | alliant | arm | c1 | c2 | mips | pyramid | tron | a29k \
- | rtpc | rs6000 | i960 | none)
- ;;
- # Recognize the basic CPU types with company name.
- vax-* | tahoe-* | i386-* | i860-* | m68k-* | m68000-* | m88k-* \
- | sparc-* | ns32k-* | alliant-* | arm-* | c1-* | c2-* \
- | mips-* | pyramid-* | tron-* | a29k-* | rtpc-* \
- | rs6000-* | i960-*)
- ;;
- # Recognize the machine names
- # which stand for a CPU time and a company.
- nindy960)
- basic_machine=i960-intel
- os=-nindy
+ # Recognize the basic CPU types with without company name.
+ tahoe | i386 | i486 | i860 | m68k | m680[01234]0 | m683?2 \
+ | m88k | ns32k | arm | pyramid \
+ | tron | a29k | 580 | i960 | h8300 | hppa1.0 | hppa1.1 | we32k\
+ | v70 | we32k | z8k)
+ basic_machine=$basic_machine-unknown
+ ;;
+ # Recognize the basic CPU types with with company name.
+ vax-* | tahoe-* | i386-* | i486-* | i860-* | m68k-* \
+ | m680[01234]0-* | m683?2-* | m88k-* \
+ | sparc-* | ns32k-* | alliant-* | arm-* | c[123]* \
+ | mips-* | pyramid-* | tron-* | a29k-* | romp-* | rs6000-* \
+ | none-* | 580-* | cray2-* | h8300-* | i960-* | xmp-* | ymp-* \
+ | hppa1.0-* | hppa1.1-* | we32k-* | z8k-*)
+ ;;
+ # Recognize the various machine names and aliases which stand
+ # for a CPU type and a company and sometimes even an OS.
+# start-sanitize-life
+ life-*) ;;
+ life)
+ basic_machine=life-philips
+ os=-none
+ ;;
+# end-sanitize-life
+
+# start-sanitize-v9
+ sparc64-*) ;;
+ hal-32 | hal32)
+ basic_machine=sparc64-hal
+ os=-hal32
;;
- vxworks68)
- basic_machine=m68k-wrs
- os=-vxworks
+ hal-64 | hal64)
+ basic_machine=sparc64-hal
+ os=-hal64
;;
- vxworks960)
- basic_machine=i960-wrs
- os=-vxworks
+ sparc64)
+ basic_machine=sparc64-sun
+ os=-v9
;;
- am29k)
- basic_machine=a29k-unknown
+ sparc64-v7 | sparc64v7)
+ basic_machine=sparc64-sun
+ os=-v7
+ ;;
+# end-sanitize-v9
+
+ vaxv)
+ basic_machine=vax-dec
+ os=-sysv
+ ;;
+ vms)
+ basic_machine=vax-dec
+ os=-vms
+ ;;
+ i386mach)
+ basic_machine=i386-mach
+ os=-mach
+ ;;
+ i386v32)
+ basic_machine=i386-unknown
+ os=-sysv32
+ ;;
+ i386-sco* | i386sco | sco)
+ basic_machine=i386-unknown
+ os=-scosysv322
+ ;;
+ go32 | i386-go32)
+ basic_machine=i386-unknown
+ os=-go32
+ ;;
+ i386-isc* | isc)
+ basic_machine=i386-unknown
+ os=-iscsysv
+ ;;
+ i386-linux* | linux)
+ basic_machine=i386-unknown
+ os=-linux
+ ;;
+ i386v4*)
+ basic_machine=i386-unknown
+ os=-sysv4
+ ;;
+ i486v4*)
+ basic_machine=i486-unknown
+ os=-sysv4
+ ;;
+ i386v)
+ basic_machine=i386-unknown
+ os=-sysv
+ ;;
+ i486v)
+ basic_machine=i486-unknown
+ os=-sysv
+ ;;
+ 386bsd)
+ basic_machine=i386-unknown
os=-bsd
;;
- umax)
- basic_machine=ns32k-umax
- os=-sysv # maybe?
+ spur)
+ basic_machine=spur-unknown
;;
- pn)
- basic_machine=pn-gould
- os=-sysv # maybe?
+ alliant)
+ basic_machine=alliant-alliant
;;
- np1)
- basic_machine=np1-gould
- os=-sysv # maybe?
+ convex-c1)
+ basic_machine=c1-convex
+ os=-sysv
+ ;;
+ convex-c2)
+ basic_machine=c2-convex
+ os=-sysv
+ ;;
+ convex-c32)
+ basic_machine=c32-convex
+ os=-sysv
+ ;;
+ convex-c34)
+ basic_machine=c34-convex
+ os=-sysv
+ ;;
+ convex-c38)
+ basic_machine=c38-convex
+ os=-sysv
+ ;;
+ m88k-omron*)
+ basic_machine=m88k-omron
;;
merlin)
- basic_machine=merlin-utek
- os=-sysv # maybe?
+ basic_machine=ns32k-utek
+ os=-sysv
+ ;;
+ crds | unos)
+ basic_machine=m68k-crds
+ ;;
+ encore | umax | mmax)
+ basic_machine=ns32k-encore
+ os=-sysv
+ ;;
+ genix)
+ basic_machine=ns32k-ns
;;
- iris | iris4d)
+ iris | iris3 | iris4d)
basic_machine=mips-sgi
- os=-sysv # maybe?
+ os=-irix3
;;
- news1000)
- basic_machine=m68030-sony
- os=-sysv # maybe?
+ iris4)
+ basic_machine=mips-sgi
+ os=-irix4
;;
news | news700 | news800 | news900)
basic_machine=m68k-sony
- os=-sysv # maybe?
+ os=-newsos
;;
- unixpc | safari | pc7300 | 3b1 | 7300 | 7300-att | att-7300)
+ 3b1 | 7300 | 7300-att | att-7300 | pc7300 | safari | unixpc)
basic_machine=m68k-att
- os=-sysv # maybe?
+ ;;
+ 3b* | we32k* )
+ basic_machine=we32k-att
+ os=-sysv
;;
delta | 3300 | motorola-3300 | motorola-delta \
| 3300-motorola | delta-motorola)
basic_machine=m68k-motorola
- os=-sysv # maybe?
- ;;
- vax-dec)
- basic_machine=vax
- os=-ultrix # maybe?
;;
balance)
basic_machine=ns32k-sequent
os=-dynix
;;
- mmax)
- basic_machine=ns32k-encore
- os=-sysv # maybe?
+ pc532)
+ basic_machine=ns32k-pc532
;;
symmetry)
basic_machine=i386-sequent
;;
sun2)
basic_machine=m68000-sun
- os=-sunos4
;;
sun2os3)
basic_machine=m68000-sun
basic_machine=m68000-sun
os=-sunos4
;;
- sun3)
- basic_machine=m68k-sun
- os=-sunos4
- ;;
sun3os3)
basic_machine=m68k-sun
os=-sunos3
basic_machine=m68k-sun
os=-sunos4
;;
- sun4)
- basic_machine=sparc-sun
- os=-sunos4
- ;;
sun4os3)
basic_machine=sparc-sun
os=-sunos3
basic_machine=sparc-sun
os=-sunos4
;;
+ sun4sol2)
+ basic_machine=sparc-sun
+ os=-solaris2
+ ;;
+ z8ksim)
+ basic_machine=z8k-unknown
+ os=-sim
+ ;;
+ sun3)
+ basic_machine=m68k-sun
+ ;;
+ sun4)
+ basic_machine=sparc-sun
+ ;;
+ msdos)
+ basic_machine=i386-unknown
+ os=-msdos
+ ;;
pbd)
basic_machine=sparc-unicom
- os=-sysv
;;
- roadrunner | sun386 | sun386i)
+ sun386 | sun386i | roadrunner)
basic_machine=i386-sun
- os=-sunos
;;
ps2)
basic_machine=i386-ibm
- os=-sysv # maybe?
- ;;
- i386sco)
- basic_machine=i386-sco
- os=-sysv # maybe?
- ;;
- i386v)
- basic_machine=i386-unknown
- os=-sysv
- ;;
- i386v32)
- basic_machine=i386-unknown
- os=-sysv32
;;
next)
basic_machine=m68k-next
- os=-sysv # maybe?
- ;;
- hp300bsd)
- basic_machine=m68k-hp
os=-bsd
;;
- hp300hpux | hpux | hp9k3[2-9][0-9])
+ hp9k3[2-9][0-9])
basic_machine=m68k-hp
- os=-hpux
;;
hp9k31[0-9] | hp9k2[0-9][0-9])
basic_machine=m68000-hp
- os=-hpux
;;
- isi | isi68)
+ hp9k7[0-9][0-9] | hp7[0-9][0-9] | hp9k8[0-9]7 | hp8[0-9]7)
+ basic_machine=hppa1.1-hp
+ ;;
+ hp9k8[0-9][0-9] | hp8[0-9][0-9])
+ basic_machine=hppa1.0-hp
+ ;;
+ isi68 | isi)
basic_machine=m68k-isi
- os=-sysv # maybe?
+ os=-sysv
;;
apollo68)
basic_machine=m68k-apollo
- os=-sysv # maybe?
+ os=-sysv
;;
- altos | altos3068)
- basic_machine=m68k-altos
- os=-sysv # maybe?
+ apollo68bsd)
+ basic_machine=m68k-apollo
+ os=-bsd
;;
- altosgas)
+ altos | altos3068)
basic_machine=m68k-altos
- os=-gas
;;
miniframe)
basic_machine=m68000-convergent
- os=-sysv # maybe?
;;
tower | tower-32)
basic_machine=m68k-ncr
- os=-sysv # maybe?
;;
- bigmips | news-3600 | risc-news)
+ news-3600 | risc-news)
basic_machine=mips-sony
- os=-newsos # maybe?
+ os=-newsos
;;
- littlemips)
- basic_machine=mips-little
- os=-bsd
+ st2000)
+ basic_machine=m68kmote-tandem
;;
- dec3100 | decstatn | decstation | decstation-3100 | pmax)
+ decstation-dec | decstation | decstation-3100 | pmax | pmin | dec3100 | decstatn)
basic_machine=mips-dec
- os=-ultrix
;;
magnum | m3230)
basic_machine=mips-mips
- os=-sysv # maybe?
+ os=-sysv
;;
gmicro)
- basic_machine=tron
- os=-sysv # maybe?
+ basic_machine=tron-gmicro
+ os=-sysv
;;
- convex-c1)
- basic_machine=c1-convex
- os=-sysv # maybe?
+ rtpc | rtpc-*)
+ basic_machine=romp-ibm
;;
- convex-c2)
- basic_machine=c2-convex
- os=-sysv # maybe?
+ am29k)
+ basic_machine=a29k-none
+ os=-bsd
+ ;;
+ amdahl)
+ basic_machine=580-amdahl
+ os=-sysv
+ ;;
+ amigados)
+ basic_machine=m68k-cbm
+ os=-amigados
+ ;;
+ amigaunix | amix)
+ basic_machine=m68k-cbm
+ os=-sysv4
+ ;;
+ stratus)
+ basic_machine=i860-stratus
+ os=-sysv4
+ ;;
+ cray | ymp)
+ basic_machine=ymp-cray
+ os=-unicos
+ ;;
+ cray2)
+ basic_machine=cray2-cray
+ os=-unicos
+ ;;
+ xmp)
+ basic_machine=xmp-cray
+ os=-unicos
+ ;;
+ delta88)
+ basic_machine=m88k-motorola
+ os=-m88kbcs
+ ;;
+ dpx2)
+ basic_machine=m68k-bull
+ os=-sysv
+ ;;
+ ebmon29k)
+ basic_machine=a29k-amd
+ os=-ebmon
+ ;;
+
+ h8300hms)
+ basic_machine=h8300-hitachi
+ os=-hms
+ ;;
+ udi29k)
+ basic_machine=a29k-amd
+ os=-udi
+ ;;
+ a29khif)
+ basic_machine=a29k-amd
+ os=-udi
+ ;;
+ sa29200)
+ basic_machine=a29k-amd
+ os=-udi
+ ;;
+ h8300xray)
+ basic_machine=h8300-hitachi
+ os=-xray
+ ;;
+ harris)
+ basic_machine=m88k-harris
+ os=-m88kbcs
+ ;;
+ hp300bsd)
+ basic_machine=m68k-hp
+ os=-bsd
+ ;;
+ hp300hpux)
+ basic_machine=m68k-hp
+ os=-hpux
+ ;;
+ hp9k2[0-9][0-9] | hp9k31[0-9])
+ basic_machine=m68000-hp
+ os=-hpux
+ ;;
+ hp9k3[2-9][0-9])
+ basic_machine=m68k-hp
+ os=-hpux
+ ;;
+ hppabsd)
+ basic_machine=hppa-hp
+ os=-bsd
+ ;;
+ hppahpux)
+ basic_machine=hppa-hp
+ os=-hpux
+ ;;
+ ncr3000)
+ basic_machine=i486-ncr
+ os=-sysv4
+ ;;
+ necv70)
+ basic_machine=v70-nec
+ os=-sysv
+ ;;
+ news1000)
+ basic_machine=m68030-sony
+ os=-newsos
+ ;;
+ nindy960)
+ basic_machine=i960-intel
+ os=-nindy
+ ;;
+ pn)
+ basic_machine=pn-gould
+ os=-sysv
+ ;;
+ np1)
+ basic_machine=np1-gould
+ os=-sysv
+ ;;
+ ultra3)
+ basic_machine=a29k-nyu
+ os=-sym1
+ ;;
+ vxworks960)
+ basic_machine=i960-wrs
+ os=-vxworks
+ ;;
+ vxworks68)
+ basic_machine=m68k-wrs
+ os=-vxworks
+ ;;
+ es1800 | OSE68k | ose68k)
+ basic_machine=m68k-ericsson
+ os=-ose
+ ;;
+ OSE68000 | ose68000)
+ basic_machine=m68000-ericsson
+ os=-ose
+ ;;
+ os68k)
+ basic_machine=m68k-none
+ os=-os68k
+ ;;
+ sparclite)
+ basic_machine=sparclite-fujitsu
+ os=-none
+ ;;
+ sparclite-wrs)
+ basic_machine=sparclite-wrs
+ os=-vxworks
+ ;;
+ sparcfrw)
+ basic_machine=sparcfrw-sun
+ os=-sunos4
+ ;;
+ sparcfrwcompat)
+ basic_machine=sparcfrwcompat-sun
+ os=-sunos4
+ ;;
+ sparclitefrw)
+ basic_machine=sparclitefrw-fujitsu
+ os=-none
+ ;;
+ sparclitefrwcompat)
+ basic_machine=sparclitefrwcompat-fujitsu
+ os=-none
+ ;;
+ adobe68k)
+ basic_machine=m68010-adobe
+ os=-scout
+ ;;
+
+ none)
+ basic_machine=none-none
+ os=-none
+ ;;
+
+# Here we handle the default manufacturer of certain CPU types. It is in
+# some cases the only manufacturer, in others, it is the most popular.
+ mips)
+ basic_machine=mips-mips
+ ;;
+ romp)
+ basic_machine=romp-ibm
+ ;;
+ rs6000)
+ basic_machine=rs6000-ibm
+ ;;
+ vax)
+ basic_machine=vax-dec
+ ;;
+ sparc)
+ basic_machine=sparc-sun
+ ;;
+ fx2800)
+ basic_machine=i860-alliant
;;
*)
echo Invalid configuration \`$1\': machine \`$basic_machine\' not recognized 1>&2
# Decode manufacturer-specific aliases for certain operating systems.
+if [ "$os" ]
+then
case $os in
# First accept the basic system types.
# The portable systems comes first.
- -bsd* | -sysv* | -mach* \
- | -vms* | -sco* | -esix* | -isc* | -aix* | -sunos* | -hpux* \
- | -unos* | -osf* | -v88r* | -aout | -coff | -bout \
- | -nindy | -vxworks)
- ;;
- -newsos*)
- os=-bsd
- ;;
- -ultrix*)
- os=-bsd
- ;;
+ # Each alternative must end in a *, to match a version number.
+ -bsd* | -sysv* | -mach* | -minix* | -genix* | -ultrix* \
+ | -aout | -coff | -elf \
+ | -vms* | -sco* | -esix* | -isc* | -aix* | -sunos* | -hpux* \
+ | -unos* | -osf* | -v88r* | -luna* | -dgux* | -solaris* | -sym* \
+ | -newsos | -amigados* | -msdos* | -none* | -os68k* | -irix* \
+ | -nindy* | -vxworks* | -ebmon* | -udi | -hms* | -xray \
+ | -m88kbcs* | -go32 | -linux* | -sim | -es1800*)
+ ;;
+# start-sanitize-v9
+ -v7 | -v9 | -hal32 | -hal64) ;;
+# end-sanitize-v9
+
+# Note that readline checks for newsos
+# -newsos*)
+# os=-bsd
+# ;;
-osfrose*)
os=-osf
;;
-dynix*)
os=-bsd
;;
- -ctix*)
+ -aos*)
+ os=-bsd
+ ;;
+ -386bsd)
+ os=-bsd
+ ;;
+ -ctix* | -uts*)
os=-sysv
;;
+ -svr4)
+ os=-sysv4
+ ;;
+ -svr3)
+ os=-sysv3
+ ;;
+ -ose*)
+ os=-ose
+ ;;
+ -es1800*)
+ os=-ose
+ ;;
*)
# Get rid of the `-' at the beginning of $os.
os=`echo $1 | sed 's/[^-]*-//'`
exit 1
;;
esac
+else
+
+# Here we handle the default operating systems that come with various machines.
+# The value should be what the vendor currently ships out the door with their
+# machine or put another way, the most popular os provided with the machine.
+case $basic_machine in
+ *-dec | vax-*)
+ os=-ultrix42
+ ;;
+ i386-sun)
+ os=-sunos402
+ ;;
+ m68000-sun)
+ os=-sunos3
+ # This also exists in the configure program, but was not the
+ # default.
+ # os=-sunos4
+ ;;
+ sparc-* | *-sun)
+ os=-sunos411
+ ;;
+ romp-*)
+ os=-bsd
+ ;;
+ *-ibm)
+ os=-aix
+ ;;
+ *-hp)
+ os=-hpux
+ ;;
+ *-sgi | i860-* | *-att | *-ncr | *-altos | *-motorola | *-convergent)
+ os=-sysv
+ ;;
+ *-dg)
+ os=-dgux
+ ;;
+ m88k-omron*)
+ os=-luna
+ ;;
+ *-crds)
+ os=-unos
+ ;;
+ *-ns)
+ os=-genix
+ ;;
+ i386-*)
+ os=-scosysv322
+ ;;
+ *)
+ os=-none
+ ;;
+esac
+fi
+
+# Here we handle the case where we know the os, and the CPU type, but not the
+# manufacturer. We pick the logical manufacturer.
+vendor=unknown
+case $basic_machine in
+ *-unknown)
+ case $os in
+ -sunos*)
+ vendor=sun
+ ;;
+ -aix*)
+ vendor=ibm
+ ;;
+ -hpux*)
+ vendor=hp
+ ;;
+ -unos*)
+ vendor=crds
+ ;;
+ -dgux*)
+ vendor=dg
+ ;;
+ -luna*)
+ vendor=omron
+ ;;
+ -genix*)
+ vendor=ns
+ ;;
+ -vxworks*)
+ vendor=wrs
+ ;;
+ esac
+ basic_machine=`echo $basic_machine | sed "s/unknown/$vendor/"`
+ ;;
+esac
-echo ${basic_machine}${os}
+echo $basic_machine$os